package samples.sign;

import javax.xml.rpc.handler.*;
import javax.xml.rpc.handler.soap.SOAPMessageContext;
import javax.xml.soap.SOAPMessage;
import javax.xml.namespace.QName;
import org.w3c.dom.*;
import org.xml.sax.InputSource;
import org.apache.axis.encoding.DeserializationContextImpl;
import org.apache.axis.message.*;
import org.apache.axis.utils.*;
import org.apache.axis.Message;
import org.apache.xml.security.c14n.Canonicalizer;
import org.apache.xml.security.signature.XMLSignature;
import org.apache.axis.Constants;
import java.util.Map;
import java.io.*;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.security.cert.X509Certificate;

public class SignHandler extends GenericHandler {

    private final String WSSENS = "http://schemas.xmlsoap.org/ws/2002/04/secext";
    private final String WSSEprefix = "wsse";

    // 閧
    private PrivateKey privateKey = null;
    
    // ؖ
    private X509Certificate cert = null;

    static {
      // XML Security̏DpOɈxs
      org.apache.xml.security.Init.init();
    }

    // \bhDCX^XɎs
    public void init(HandlerInfo config) {
        try {
            // p[^Xg̎擾
            Map map = config.getHandlerConfig();

            // WSDDt@CŎw肵p[^擾
            String keystoreFile = (String)map.get("keystoreFile");
            String keystorePass = (String)map.get("keystorePass");
            String privateKeyAlias = (String)map.get("privateKeyAlias");
            String privateKeyPass = (String)map.get("privateKeyPass");
            Object certificateAlias = map.get("certificateAlias");

	    System.err.println("keystoreFile="+keystoreFile);
	    System.err.println("keystorePass="+keystorePass);
	    System.err.println("privateKeyAlias="+privateKeyAlias);
	    System.err.println("privateKeyPass="+privateKeyPass);
	    System.err.println("certificateAlias="+certificateAlias);

            // L[XgA̎擾
            KeyStore ks = KeyStore.getInstance(KeyStore.getDefaultType());
            FileInputStream fis = new FileInputStream(keystoreFile);
            ks.load(fis, keystorePass.toCharArray());
      
            // 閧擾
            privateKey = (PrivateKey) ks.getKey(privateKeyAlias,
                                                privateKeyPass.toCharArray());
            // ؖ擾
            if (certificateAlias !=null) {
                cert = (X509Certificate) ks.getCertificate(((String)certificateAlias));
            }
            
        } catch (Exception e){e.printStackTrace();}
    }
    

    // snh
    public boolean handleRequest(MessageContext context){

        try {
            // SOAPGx[v擾
            SOAPMessage message =
		((SOAPMessageContext)context).getMessage();
            SOAPEnvelope envelope = 
		(org.apache.axis.message.SOAPEnvelope)
		message.getSOAPPart().getEnvelope();

	    // WS-Securirỹl[Xy[Xݒ
            envelope.addMapping(new Mapping(WSSENS, WSSEprefix));

            // WS-SecurityŋK肳ꂽSeurityvf܂SOAPwb_𐶐
            SOAPHeaderElement header 
                = new SOAPHeaderElement(
                     XMLUtils.StringToElement(WSSENS, "Security",""));

	    // SOAPGx[vSOAPwb_ǉ
            envelope.addHeader(header);

            // SOAPGx[vDOMDocumentƂĎ擾
            Document envdoc = envelope.getAsDocument();

            // EnvelopeSecurityvf擾
            Element soapHeaderElement 
		= (Element)((Element) envdoc.getFirstChild()).
			getElementsByTagNameNS("*", "Header").item(0);

            Element securityElement 
		= (Element)soapHeaderElement.
			getElementsByTagNameNS("*", "Security").item(0);

	    // XMLSignaturẽCX^X𐶐D
	    //   + ASY
	    //     DSAiXMLSignature.ALGO_ID_SIGNATURE_DSAjw
	    //   + KASY
	    //     Canonicalizer.ALGO_ID_C14N_OMIT_COMMENTSw
	    //     iRg폜ďsj 
            XMLSignature sig 
                = new XMLSignature
		    (envdoc, 
		     "http://xml-security", 
		     XMLSignature.ALGO_ID_SIGNATURE_DSA,
		     Canonicalizer.ALGO_ID_C14N_WITH_COMMENTS);

            // Signature^O̎qm[hɏǉ
            securityElement.appendChild(sig.getElement());

            // #Body^O̒gΏۂɐݒ
            sig.addDocument("#Body");


            // ؖSOAPbZ[WɓYt
            // (T[oŏؖo^Ăꍇ͕KvȂ)
            if (cert != null) {
                sig.addKeyInfo(cert);
            }

            // s
            sig.sign(privateKey);

            // XMLSignatureɎw肵ASY
            // (Canonicalizer.ALGO_ID_C14N_WITH_COMMENTS)ŐK
            // oCgɕϊD
            Canonicalizer c14n =
                Canonicalizer.getInstance
		(Canonicalizer.ALGO_ID_C14N_WITH_COMMENTS);
            byte[] canonicalMessage = c14n.canonicalizeSubtree(envdoc);
            InputSource is = new InputSource
		(new java.io.ByteArrayInputStream(canonicalMessage));

            // bZ[WReLXgɐKXMLݒ
            DeserializationContextImpl dser 
                = new DeserializationContextImpl
		    (is, 
		     (org.apache.axis.MessageContext)context,
		     Message.REQUEST,
		     envelope);
            dser.parse();

        } catch (Exception e) {
            e.printStackTrace();
	    return false;
        }
	return true;
    }

  // wb_̕ԋp
  public QName[] getHeaders() {
    return null;
  }
}