package samples.sign;

import javax.xml.rpc.handler.*;
import javax.xml.rpc.handler.soap.SOAPMessageContext;
import javax.xml.soap.SOAPMessage;
import javax.xml.namespace.QName;
import javax.xml.rpc.JAXRPCException;

import java.util.Map;
import java.io.FileOutputStream;
import java.io.PrintWriter;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.apache.axis.message.SOAPEnvelope;
import org.apache.axis.AxisFault;

import org.apache.xpath.CachedXPathAPI;
import org.apache.xml.security.signature.XMLSignature;
import org.apache.xml.security.utils.Constants;

public class VerifyHandler extends GenericHandler {

    static {
        org.apache.xml.security.Init.init();
    }
    
    // snh
    // ؂ɐCsignaturevpeBtrueC
    // sfalseݒ肷D
    public boolean handleRequest(MessageContext context) {
        try {
            // SOAPGx[vDOMƂĎ擾
            SOAPMessage message =
		((SOAPMessageContext)context).getMessage();

            Document doc = 
		((SOAPEnvelope)message.getSOAPPart().getEnvelope())
		.getAsDocument();

            String BaseURI = "http://xml-security";

            // Signaturevf擾
            CachedXPathAPI xpathAPI = new CachedXPathAPI();

            Element nsctx = doc.createElement("nsctx");
            nsctx.setAttribute("xmlns:ds", Constants.SignatureSpecNS);

            Element signatureElem = (Element) xpathAPI.selectSingleNode(doc,
                    "//ds:Signature", nsctx);

            // 񂪂Ȃ΂̂܂܏I
            if (signatureElem == null) {
              System.out.println("The document is not signed");

              // bZ[WReLXgsignaturefalse
              // (؂Ɏs)ݒ
	      context.setProperty("signature", new Boolean(false));
              throw new JAXRPCException("The signature doesn't exist");
            }

            // Ytꂽؖŏ
            XMLSignature sig = new XMLSignature(signatureElem, BaseURI);

            // Ytꂽؖŏ
            boolean verify = sig.checkSignatureValue(sig.getKeyInfo().getPublicKey());
            System.out.println("Server verification complete.");

            System.out.println("The signature is" + (verify
                    ? " "
                    : " not ") + "valid");
	    if (!verify) {
              context.setProperty("signature", new Boolean(false));
              throw new JAXRPCException("The signature is invalid");
	    }
            // bZ[WReLXgsignaturetrue
            // (؂ɐ)ݒ
            context.setProperty("signature", new Boolean(true));
            return true;
        } catch (Exception e) {
            // bZ[WReLXgsignaturefalse
            // (؂Ɏs)ݒ
            context.setProperty("signature", new Boolean(false));
            throw new JAXRPCException(e);
        }
    }
    // wb_̕ԋp
    public QName[] getHeaders() {
        return null;
    }
}